@/data/kbah/code/FGF/mesoscale/newdownscale/sub_pro/READ_ABI_NETCDF_01.PRO
@/data/kbah/code/FGF/mesoscale/newdownscale/sub_pro/SUBSET_DATA.PRO
@/data/kbah/code/FGF/mesoscale/newdownscale/sub_pro/WRITE_GRB_SCALED_NETCDF.PRO
@/data/kbah/code/FGF/mesoscale/newdownscale/sub_pro/DOWNSCALED_DATA.PRO
@/data/kbah/code/FGF/mesoscale/newdownscale/sub_pro/SIMPLE_AVG_DATA.PRO
@/data/kbah/code/FGF/mesoscale/newdownscale/sub_pro/WRITE_VAL_FROM_GRB_SCALED_NETCDF.PRO

;;;;;sub_routines

FUNCTION READ_FILES,infiles,latlonfile, vars
	data=READ_ABI_NETCDF_01(infiles(0),vars, nvars=1, lineele=0)
  latlon=READ_ABI_NETCDF_01(latlonfile,vars, xx=5534, yy=1, nvars=2, lineele=1)	
 	datalatlon={data:data, latlon:latlon}
 RETURN, datalatlon	
END

FUNCTION GET_FILES,inpre=inpre, aband=aband, time=time, ii=ii
	IF not keyword_set(inpre) then message, 'Provide input file location'
	IF not keyword_set(aband) then message, 'Provide the band number to process'
	
	  inpre2='' ;'2km/'
	  IF (ii LE 5 AND ii NE 4) THEN inpre2='' ;'/1km/'
	  inpre2=inpre+inpre2
	  inpre0='/data/kbah/input_data/FGF/latlon/'
	  sub1='*'+aband+'*'+time+'*' & sub2='*75W_lines_elements*'   
	  
	  datafiles=FIlE_SEARCH(inpre2, sub1)
    print,datafiles
	  lineselements=FILE_SEARCH(inpre0,sub2)

	  info={data:datafiles, lineselements:lineselements}
    RETURN, info
END


PRO MAKE_BANDLOOP,infiles, outpre1,outpre2, num_files,multivar,ii, avg=avg, var=var
     tot_newfiles=N_ELEMENTS(infiles.data)
     IF (tot_newfiles GE 1) THEN BEGIN 	
	FOR jj=0, tot_newfiles-1 DO BEGIN  ;tot_newfiles-1
		spos=STRPOS(infiles.data(jj),'1km_',  /REVERSE_SEARCH) ;
		epos=STRPOS(infiles.data(jj), '.',    /REVERSE_SEARCH) 
		outpost=STRMID(infiles.data(jj), spos+4, (epos-spos-4))
		
		
       var=0
   IF (ii LE 6) THEN var=0 ;1
  
	     data=READ_FILES(infiles.data(jj), infiles(0).lineselements,var)
    
    
          IF (avg EQ 0) THEN BEGIN
            outpre1=outpre1+'Sub_sampled_GRB_scaled_2km_'+ outpost   ;
            outpre2=outpre2+'Sub_sampled_Validation_2km_'+ outpost   
            smethod='Sub Sampled'  ;
            sdata=DOWNSCALED_DATA(data)
         ENDIF  ELSE BEGIN
              outpre1=outpre1+'Simple_AVG_GRB_scaled_2km_'+ outpost   ;Sub_sampled
              outpre2=outpre2+'Simple_AVG_Validation_2km_'+ outpost
              smethod='Simple Averaged'  ;'Sub Sampled'  ; 
              sdata=SIMPLE_AVG_DATA(data, spacing=2)
         ENDELSE   
 
    WRITE_GRB_SCALED_NETCDF,sdata, outpre1, ii, multivar,katr, smethod=smethod
    WRITE_VAL_FROM_GRB_SCALED_NETCDF, outpre1, outpre2, ii, multivar,var=var,infiles(0).lineselements, smethod=smethod

    	    
	ENDFOR
  ENDIF	
END


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;Main program
;;;;;;;;;****************************************************************
PRO NETCDF_GRB_VAL_NETCDF_FGF

	;;;;;Variables	
		outpreg='/data/kbah/output/FGF/mesoscale/downscale/GRB/'  
		outprev='/data/kbah/output/FGF/mesoscale/downscale/VAL/'  
	  inpre0='/data/kbah/output/FGF/mesoscale/GRB/testcase/'
		multivar=0 & katr=0 & times=['1200']
	  avg=1  & var=0;0
		
FOR ii=1, 5 DO BEGIN  ;7 ,16

		inpre=inpre0 & bnum=STRING(STRTRIM(ii,1))
		
		IF ii LT 10 THEN bnum='0'+ STRING(STRTRIM(ii,1))
		aband=STRING('band'+bnum)
;		sub='2km/'
;
;		IF (ii LE 3 OR ii EQ 5) THEN sub='1km/'  
;		inpre=inpre+sub
		nt=n_elements(times)
    for ntime=0,nt-1 do begin
               time=times(ntime)
              ;  help,time
                outpre1= outpreg &  outpre2= outprev  ;aband+'/'
                
              infiles=GET_FILES(inpre=inpre, aband=aband, time=time, ii=ii)
              MAKE_BANDLOOP,infiles, outpre1, outpre2, num_files, multivar,ii, avg=avg, var=var
    endfor
     
      ii=ii+1
	  ; PRINT, ii 

	ENDFOR	

END          
;;;;;;;*****************************************************************




