FUNCTION SIMPLE_AVG_DATA, data, spacing=space

  dlines=data.latlon.lines
  delements=data.latlon.elements
  adata=data.data.dataset.data

  ll=ROUND(size(dlines, /n_elements)) ;/space)
  ee=ROUND(size(delements, /n_elements))  ;/space)
 
  ;dlines=FLTARR(ll) & delements=FLTARR(ee)  & 
  ddata=FLTARR(ll, ee)
  zz=SIZE(adata) & aa=zz[1] & bb=zz[2] & tmpa=FLTARR(space,space)
  
  FOR x=0, ll-1  DO BEGIN
            ; dlines(x)=lines(x*space)
      FOR y=0, ee-1 DO BEGIN
              w=space*x &  z=space*y & count=0
              tmpa[0,0]=adata(w,z)       ;0,0
              tmpa[0,1]=adata(w,z+1)     ;0,1
              tmpa[1,0]=adata(w+1,z)     ;1,0
              tmpa[1,1]=adata(w+1,z+1)   ;1,1
              ff=where(tmpa GT 0)
              gg=N_ELEMENTS(ff)
              IF (gg GT 1) THEN ddata(x,y)=TOTAL(tmpa(ff))/FLOAT(gg)
              IF (gg EQ 0) THEN ddata(x,y)=adata(x*space, y*space) 
              IF (gg EQ 1) THEN ddata(x,y)=tmpa(ff)    ;adata(x*space, y*space) 
              ;IF (gg EQ 1) THEN ddata(x,y)=adata(ff)           
               ; IF (x eq 0) THEN delements(y)=elements(y*2)
      ENDFOR     
      ; print, 'stop'
  ENDFOR
  
  
  ;;;;;;;;;;;;;;;;reading lines & elements from 2km grid
  ;;;;;;;;;;;;;;;;no needto resample from 1km  files

   dataset={data:ddata,attr:data.data.dataset.attr, attrval:data.data.dataset.attrval}
   dscaled={dataset:dataset, lines:dlines, elements:delements}
 
  RETURN, dscaled

END